-- functions.lua
-- Written By Habna


function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

-- **v Unload v**
function UnloadHugeBag()
	--write( "HugeBag: Unloaded" );
	--Turbine.PluginManager.UnloadScriptState( 'HugeBag' );
	Turbine.PluginManager.LoadPlugin( 'HugeBag Unloader' );
end
-- **^
-- **v Reload v**
function ReloadHugeBag()
	--write( "HugeBag: Reloaded" );
	--UnloadHugeBag();
	--Turbine.PluginManager.LoadPlugin( 'HugeBag' );
	Turbine.PluginManager.LoadPlugin( 'HugeBag Reloader' );
end
-- **^
-- **v Toggle the ability to hide are not HugeBag when the 'esc' key is press v**
function ToggleWEsc()
	HideWEsc = not HideWEsc;
	SaveSettings();
	if HideWEsc then write( L["FEscH"] );
	else write( L["FEscS"] ); end
end
-- **^
-- **v Toggle Startup Visibility v**
function ToggleShow()
	StartVisible = not StartVisible;
	SaveSettings();
	if StartVisible then write( L["FLoadS"] );
	else write( L["FLoadH"] ); end
end
-- **^
-- **v Toggle between window and widget mode v**
function ToggleMode()
	Widget = not Widget;
	SaveSettings();
	if Widget then write( L["FWidget"] );
	else write( L["FWin"] ); end
end
-- **^
-- **v Toggle ability to be always on top are not v**
function ToggleAlwaysOnTop()
	zOrder = not zOrder;
	SaveSettings();
	if zOrder then write( L["FAOTS"] );
	else write( L["FAOTH"] ); end
end
-- **^
-- **v Toggle bottom bar info v**
function ToggleBotBarInfo(value)
	if IsSorting or IsMixing or IsMerging or IsSearching then
		write( L["FWidActive"] );
		return
	end
	if value == "butvis" then
		ShowButton = not ShowButton;
		if ShowButton then write( L["FWidButVis"] );
		else write( L["FWidButNVis"] ); end
	end
	PrintTitle();
	SaveSettings();
end
-- **^
-- **v Toggle inverse merge function v**
function InvMerge()
	InverseMerge = not InverseMerge;
	SaveSettings();
	if InverseMerge then write( L["FMergeD"] .. backpackSize .. L["FMerge1"] );
	else write( L["FMergeU"] .. backpackSize ); end
end
-- **^
-- **v Toggle top bar info v**
function ToggleTopBarInfo(value)
	if value == "title" then
		write( L["FWidTBTitle"] );
	elseif value == "info" then
		write( L["FWidTBInfo"] );
	elseif value == "nil" then
		write( L["FWidTBNot"] );
	end
	topbarinfo = value;
	PrintTitle();
	SaveSettings();
end
-- **^
-- **v Searching v**
function Searching()
	SearchInput:SetVisible( not SearchInput:IsVisible() );
	ButtonsCtr:SetVisible( false );
	--SortButton:SetVisible( false );
	--SearchButton:SetVisible( false );
	--MergeButton:SetVisible( false );
	ResetAllCheck(); --Reset all itemsmenu check
	SearchInput:Focus();
end
-- **^
-- **v Vault v**
function ViewVault()
	import "HabnaPlugins.HugeBag.vault"; -- LUA vault file
	frmVault();
end
-- **^
-- **v Vault v**
function ViewSharedStorage()
	import "HabnaPlugins.HugeBag.sharedstorage"; -- LUA vault file
	frmSharedStorage();
end
-- **^
-- **v Set background color v**
function SetBackgroundColor()
	import "HabnaPlugins.HugeBag.background"; -- LUA background file
	frmBackground();
end
-- **^
-- **v Show Shell Command window v**
function HelpInfo()
	import "HabnaPlugins.HugeBag.shellcmd"; -- LUA shell command file
	frmShellCmd();
end
-- **^
-- **v Show options menu v**
function ShowOptionsMenu(value)
	if value == "nil" then
		menu:ShowMenuAt(wHugeBag:GetLeft() - 350, wHugeBag:GetTop());
		if HBLocale == "fr" then menu:ShowMenuAt( wHugeBag:GetLeft() - 448, wHugeBag:GetTop() ); end
		if HBLocale == "de" then menu:ShowMenuAt( wHugeBag:GetLeft() - 419, wHugeBag:GetTop() ); end
	elseif value == "left" then
		menu:ShowMenuAt(wHugeBag:GetLeft() + wHugeBag:GetWidth() + 5, wHugeBag:GetTop());
	end
end
-- **^
-- **v Show ListBox items v**
function ShowItems(ItemsToShow)
	if ItemsToShow == "all" then
		SearchInput.FocusLost( sender, args );
	else
		if AllVisible then
			for i = 1, backpackSize do
				Item = Backpack:GetItem( i );
				if Item ~= nil then items[i]:SetVisible( false ); end
				AllVisible = false;
			end
		end
		for i = 1, backpackSize do
			Item = Backpack:GetItem( i );
			if Item ~= nil then
				ItemType = ItemCategory[Item:GetCategory()];
				if ItemsSel then
					if ItemType == ItemsToShow then	items[i]:SetVisible( true ); end
				else
					if ItemType == ItemsToShow then	items[i]:SetVisible( false ); end
				end
			end
		end
	end
end
-- **^
-- Create hacky resize cursors
function createCursor( MyCursorName, xOffset, yOffset, xSize, ySize, InGameCursor )
	cursor = Turbine.UI.Window();
	cursor:SetSize( xSize, ySize );
	if MyCursorName == nil then
		cursor:SetBackground( InGameCursor );
	else
		cursor:SetBackground( "HabnaPlugins/HugeBag/Resources/"..MyCursorName..".tga" );
	end
	cursor:SetMouseVisible( false );
	cursor:SetZOrder( 10 );
	
	cursor.xOffset = xOffset;
	cursor.yOffset = yOffset;
	
	return cursor;
end

-- Widget mode cursor
up_down_right_clic = createCursor( "up_down_right-click", 15, 12, 37, 23, nil );

-- Window mode cursor
resizeCursor = createCursor( nil, 14, 16, 32, 32, 0x410000dd ); -- in-game cursor 32x32: 0x410000dd
updownCursor = createCursor( nil, 18, 16, 32, 32, 0x410081c0 ); -- in-game cursor 32x32: 0x410081c0
leftrightCursor = createCursor( nil, 14, 16, 32, 32, 0x410081bf ); -- in-game cursor 32x32: 0x410081bf
leftrightclicCursor = createCursor( "left-right-click", 15, 15, 18, 22, nil );
--In-game normal cursor 32x32: 0x41007dc7

function ShowLeftRightCursor()
	if not LockSize then
		wHugeBag.cursor = leftrightCursor;
		local mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
		wHugeBag.cursor:SetPosition( mouseX - wHugeBag.cursor.xOffset, mouseY - wHugeBag.cursor.yOffset);
		wHugeBag.cursor:SetVisible( true );
	end
end

function ShowUpDownCursor()
	if not LockSize then
		wHugeBag.cursor = updownCursor;
		local mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
		wHugeBag.cursor:SetPosition( mouseX - wHugeBag.cursor.xOffset, mouseY - wHugeBag.cursor.yOffset);
		wHugeBag.cursor:SetVisible( true );
	end
end

function ShowTitleResizeCursor()
	if not LockPosition then
		wHugeBag.cursor = resizeCursor;
		local mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
		wHugeBag.cursor:SetPosition( mouseX - wHugeBag.cursor.xOffset, mouseY - wHugeBag.cursor.yOffset);
		wHugeBag.cursor:SetVisible( true );
	end
end

function ShowResizeCursor()
	if not LockSize then
		wHugeBag.cursor = resizeCursor;
		local mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
		wHugeBag.cursor:SetPosition( mouseX - wHugeBag.cursor.xOffset, mouseY - wHugeBag.cursor.yOffset);
		wHugeBag.cursor:SetVisible( true );
	end
end

function ShowResizeRightClicCursor()
	if not LockSize then
		wHugeBag.cursor = resizeRightClicCursor;
	else
		wHugeBag.cursor = rightclicCursor;
	end
	local mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
	wHugeBag.cursor:SetPosition( mouseX - wHugeBag.cursor.xOffset, mouseY - wHugeBag.cursor.yOffset);
	wHugeBag.cursor:SetVisible( true );
end

function mergetable(table1,list)
	for i = 1, #list do
		table2 = list[i];
		local LenTable1 = #table1;
		for a = LenTable1 + 1, #table1 + #table2 do
			table1[a] = table2[a - LenTable1];
		end
	end
end

function ChangeColor()
	wHugeBag.itemListBox:SetBackColor( Turbine.UI.Color( bcAlpha, curSelRed, curSelGreen, curSelBlue ) );
end

function CreateVirtualPack()
	VirtPack = {};

	for i = 1, backpackSize do
		VirtPack[i] = {};
		VirtPack[i].AtSlot = i;

		local item = Backpack:GetItem( i );

		VirtPack[i].Item = Turbine.UI.Lotro.ItemControl( item );

		if item == nil then
			VirtPack[i].Name = "zEmpty";
			VirtPack[i].StackSize = 0;
			VirtPack[i].Quality = 0;
			VirtPack[i].Quantity = 0;
			VirtPack[i].Durability = 0;
			VirtPack[i].WearState = 0;
			VirtPack[i].CategoryNo = 0;
			VirtPack[i].Type = "nil";
			VirtPack[i].Weight = 99999;
		else
			VirtPack[i].Name = item:GetName();
			
			local StackSize = item:GetMaxStackSize();
			if StackSize == nil then StackSize = 1; end
			VirtPack[i].StackSize = StackSize;

			local Quantity = item:GetQuantity();
			if Quantity == nil then Quantity = 1; end
			VirtPack[i].Quantity = Quantity;

			local Quality = item:GetQuality();
			if Quality == nil then Quality = 0; end
			VirtPack[i].Quality = Quality;

			local Durability = item:GetDurability();
			if Durability == nil then Durability = 0; end
			VirtPack[i].Durability = Durability;

			local WearState = item:GetWearState();
			if WearState == nil then WearState = 0; end
			VirtPack[i].WearState = WearState;
			
			local CategoryNo = item:GetCategory();
			if CategoryNo == nil then CategoryNo = 0; end
			VirtPack[i].CategoryNo = CategoryNo;
			
			local Type = ItemCategory[CategoryNo];
			if Type == nil then Type = "SpecialTrophy"; end
			VirtPack[i].Type = Type;

			local CatWeight = value[Type];

			VirtPack[i].Weight = CatWeight * 10 + Quality;
		end
	end

	--Sort VirtPack. If the weight of two items is the same compare the Names, after removing some characters.
	--This way 2 Morale Potions will get sorted with "Morale Potions"
	table.sort(VirtPack, function (a,b)	
		if a.Weight == b.Weight then
			if a.Name == b.Name then
				if a.Quantity == b.Quantity then
					return (a.AtSlot < b.AtSlot)
				else
					return (a.Quantity < b.Quantity)
				end
			else  
				return strip(a.Name) < strip(b.Name)
			end
		else  
			return (a.Weight < b.Weight) 
		end
	end)
end

function strip(str)
	--Strip numbers first 7 characters to make the sort more logical
	local left=string.sub(str, 1, 7)
	local right=string.sub(str, 8)
	left=string.gsub(left,"[^%a]","")
	str= left .. right

	--Strip all spaces now!
	str=string.gsub(str,"[%s]","")
	
	return str
end

-- For debug purpose
function ShowTableContent(args)
	for k,v in pairs(args) do
		write("key:"..tostring(k)..", value:"..tostring(v));
	end
end