-- vault.lua
-- written by Habna


function frmVault()
	--wVault = Turbine.UI.Window();
	wVault = Turbine.UI.Lotro.Window()
	--wVault = Turbine.UI.Lotro.GoldWindow()
	
	wVault.cursor = nil;

	-- **v Set backcolor, position, size and text of the window v**
	wVault:SetWidth( 460 );
	wVault:SetPosition( VWLeft, VWTop );
	wVault:SetText( L["OWidVault"] );
	wVault:SetWantsKeyEvents( true );
	wVault:SetVisible( true );
	vWinWidth, vWinHeight = wVault:GetSize();
	listWidth = vWinWidth - 37;
	--wVault:SetZOrder( 2 );
	--wVault:Activate();

	wVault.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wVault:Close();
		elseif ( args.Action == 268435635 ) or ( args.Action == 268435579 ) then -- Hide if F12 key is press or reposition UI
			wVault:SetVisible( not wVault:IsVisible() );
		end
	end

	wVault.MouseUp = function( sender, args )
		HBsettings.Vault.L = string.format("%.0f", wVault:GetLeft());
		HBsettings.Vault.T = string.format("%.0f", wVault:GetTop());
		VWLeft, VWTop = wVault:GetPosition();
		SaveSettings();
	end

	wVault.Closing = function( sender, args ) -- Function for the Upper right X icon
		wVault:SetWantsKeyEvents( false );
		option_vault:SetEnabled( true );
		wVault = nil;
	end
	-- **^
	
	-- **v Set the itemlistbox v**
	wVault.ListBox = Turbine.UI.ListBox();
	wVault.ListBox:SetParent( wVault );
	wVault.ListBox:SetPosition( 17, 35 );
	wVault.ListBox:SetWidth( listWidth );
	wVault.ListBox:SetMaxItemsPerLine( 12 );
	wVault.ListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	wVault.ListBox:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0 ) );
	--**^

	-- **v Set the scrollbar v**
	wVault.ListBoxScrollBar = Turbine.UI.Lotro.ScrollBar();
	wVault.ListBoxScrollBar:SetParent( wVault );
	wVault.ListBoxScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
	wVault.ListBox:SetVerticalScrollBar( wVault.ListBoxScrollBar );
	wVault.ListBoxScrollBar:SetPosition( vWinWidth - 20, 40 );
	wVault.ListBoxScrollBar:SetSize( 10, wVault.ListBox:GetHeight() - 15 );
	-- **^

	-- **v Get player gameplay v**
	if pcall( Turbine.Gameplay.LocalPlayer.GetInstance ) then
		vaultpack = Turbine.Gameplay.LocalPlayer.GetInstance():GetVault();
	else
		vaultpack = Turbine.Gameplay.LocalPlayer():GetVault();
	end
	-- **^

	vaultpackSize = vaultpack:GetCapacity();
	--vaultpackSize = 0; --debug purpose
	
	-- Convert the table key that is in string format into a number, so it can be viewed by lua correctly.
	if PlayerVault[PN] ~= nil then
		local newt = {}
		for k, v in pairs(PlayerVault[PN]) do newt[tonumber(k)] = v; end
		PlayerVault[PN] = newt;
	end
	
	if vaultpackSize == 0 then --Vault not loaded
		if #PlayerVault[PN] == 0 then --My vault item list is empty
			local lblmgs = Turbine.UI.Label();
			lblmgs:SetParent( wVault );
			lblmgs:SetText( L["OWidNeed"]..L["OWidVault"]..L["OWidOnce"] );
			lblmgs:SetPosition( 30, 50 );
			lblmgs:SetSize( lblmgs:GetTextLength() * 7.5, 15 );
			lblmgs:SetForeColor( green );
			lblmgs:SetTextAlignment( Turbine.UI.ContentAlignment.TopCenter );

			wVault.ListBox:SetHeight( 0 );
			wVault.ListBox:SetVisible( false );
			wVault:SetSize( lblmgs:GetWidth()+60, lblmgs:GetHeight()+60 );
		else
			vaultpackSize = tonumber(PlayerVault[PN][1].Z);
			SetVaultPack();
		end
	else
		vaultpackcount = vaultpack:GetCount();
		PlayerVault[PN] = {};

		for ii = 1, vaultpackcount do
			PlayerVault[PN][tostring(ii)] = vaultpack:GetItem( ii );
			local iteminfo = PlayerVault[PN][tostring(ii)]:GetItemInfo();
			
			PlayerVault[PN][tostring(ii)].Q = tostring(iteminfo:GetQualityImageID());
			PlayerVault[PN][tostring(ii)].B = tostring(iteminfo:GetBackgroundImageID());
			PlayerVault[PN][tostring(ii)].U = tostring(iteminfo:GetUnderlayImageID());
			PlayerVault[PN][tostring(ii)].S = tostring(iteminfo:GetShadowImageID());
			PlayerVault[PN][tostring(ii)].I = tostring(iteminfo:GetIconImageID());
			local tq = tostring(PlayerVault[PN][tostring(ii)]:GetQuantity());
			if tq == "1" then tq = ""; end
			PlayerVault[PN][tostring(ii)].N = tq;
			PlayerVault[PN][tostring(ii)].Z = tostring(vaultpackSize);
		end

		Turbine.PluginData.Save( Turbine.DataScope.Server, "HugeBagVault", PlayerVault );
		SetVaultPack();
	end
end

--**v Set VaultPack v**
function SetVaultPack()
	wVault.items = nil;
	itemsCtl = nil;
	itemsLbl = nil;
	wVault.ListBox:ClearItems();
	vaultpackcount = 0;

	wVault.items = {};
	itemsCtl = {};
	itemsLbl = {};

	-- Convert the table key that is in string format into a number, so it can be viewed by lua correctly.
	local newt = {}
	for k, v in pairs(PlayerVault[PN]) do newt[tonumber(k)] = v; end
	PlayerVault[PN] = newt;

	for i = 1, vaultpackSize do
		-- Item background
		itemsCtl[i] = Turbine.UI.Control();
		itemsCtl[i]:SetSize( 35, 35 );
		itemsCtl[i]:SetBackground( resources.Item.Background );
		itemsCtl[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );

		-- Slot num in background
		itemsLbl[i] = Turbine.UI.Label();
		itemsLbl[i]:SetParent( itemsCtl[i] );
		itemsLbl[i]:SetSize( 35, 35 );
		itemsLbl[i]:SetPosition( 0, 0 );
		itemsLbl[i]:SetText( i );
		itemsLbl[i]:SetForeColor( verylightgrey );
		itemsLbl[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
		itemsLbl[i]:SetBlendMode( Turbine.UI.BlendMode.Overlay );

		if PlayerVault[PN][i] ~= nil then
			-- Item Background/Underlay/Shadow/Image
			local itemBG = Turbine.UI.Control();
			itemBG:SetParent( itemsCtl[i] );
			itemBG:SetSize( 32, 32 );
			itemBG:SetPosition( 3, 3 );
			itemBG:SetBackground(tonumber(PlayerVault[PN][i].B));
			itemBG:SetBlendMode( Turbine.UI.BlendMode.Overlay );
		
			local itemU = Turbine.UI.Control();
			itemU:SetParent( itemsCtl[i] );
			itemU:SetSize( 32, 32 );
			itemU:SetPosition( 3, 3 );
			itemU:SetBackground(tonumber(PlayerVault[PN][i].U));
			itemU:SetBlendMode( Turbine.UI.BlendMode.Overlay );

			local itemS = Turbine.UI.Control();
			itemS:SetParent( itemsCtl[i] );
			itemS:SetSize( 32, 32 );
			itemS:SetPosition( 3, 3 );
			itemS:SetBackground(tonumber(PlayerVault[PN][i].S));
			itemS:SetBlendMode( Turbine.UI.BlendMode.Overlay );

			local item = Turbine.UI.Control();
			item:SetParent( itemsCtl[i] );
			item:SetSize( 32, 32 );
			item:SetPosition( 3, 3 );
			item:SetBackground(tonumber(PlayerVault[PN][i].I));
			item:SetBlendMode( Turbine.UI.BlendMode.Overlay );

			-- Item Quantity
			itemQTE = Turbine.UI.Label();
			itemQTE:SetParent( itemsCtl[i] );
			itemQTE:SetSize( 32, 15 );
			itemQTE:SetPosition( -4, 16 );
			itemQTE:SetFont( Turbine.UI.Lotro.Font.Verdana12 );
			itemQTE:SetFontStyle( Turbine.UI.FontStyle.Outline );
			itemQTE:SetOutlineColor( black );
			itemQTE:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
			itemQTE:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
			itemQTE:SetForeColor( nicegold );
			itemQTE:SetText(tonumber(PlayerVault[PN][i].N));
			vaultpackcount = vaultpackcount+1;
		end

		wVault.ListBox:AddItem( itemsCtl[i] );
	end

	--**v Set window v** --
	freeslots = vaultpackSize - vaultpackcount;
	wVault:SetText( wVault:GetText()  .. " -- " .. L["Free"] .. freeslots .. L["Used"] .. vaultpackcount .. L["Max"] .. vaultpackSize );
	if vaultpackSize <= 75 then
		local tmpH = (math.ceil(vaultpackSize/wVault.ListBox:GetMaxItemsPerLine()))*35+3;
		wVault.ListBox:SetHeight( tmpH );
		wVault:SetHeight( wVault.ListBox:GetTop()+wVault.ListBox:GetHeight()+17 );
	else
		wVault.ListBox:SetHeight( 248 );
		wVault:SetHeight( 300 );
	end
end
-- **^